diff --git a/include/linux/sched.h b/include/linux/sched.h
index 90bd418..405121d 100644
--- a/include/linux/sched.h
+++ b/include/linux/sched.h
@@ -13,6 +13,7 @@ extern unsigned long event;
 #include <linux/times.h>
 #include <linux/timex.h>
 #include <linux/rbtree.h>
+#include <linux/ipipe.h>
 
 #include <asm/system.h>
 #include <asm/semaphore.h>
@@ -91,6 +92,11 @@ extern int last_pid;
 #define TASK_UNINTERRUPTIBLE	2
 #define TASK_ZOMBIE		4
 #define TASK_STOPPED		8
+#ifdef CONFIG_IPIPE
+#define TASK_NOWAKEUP		512
+#else  /* !CONFIG_IPIPE */
+#define TASK_NOWAKEUP		0
+#endif /* CONFIG_IPIPE */
 
 #define __set_task_state(tsk, state_value)		\
 	do { (tsk)->state = (state_value); } while (0)
@@ -144,6 +150,15 @@ extern void update_process_times(int user);
 extern void update_one_process(struct task_struct *p, unsigned long user,
 			       unsigned long system, int cpu);
 
+#ifdef CONFIG_IPIPE
+extern void update_root_process_times(struct pt_regs *regs);
+#else  /* !CONFIG_IPIPE */
+static inline void update_root_process_times(struct pt_regs *regs)
+{
+	update_process_times(user_mode(regs));
+}
+#endif /* CONFIG_IPIPE */
+
 #define	MAX_SCHEDULE_TIMEOUT	LONG_MAX
 extern signed long FASTCALL(schedule_timeout(signed long timeout));
 asmlinkage void schedule(void);
@@ -418,6 +433,9 @@ struct task_struct {
 #ifdef CONFIG_SHOW_PNAME_ON_DISPLAY
 	char PName[8]; /* 8 characters from the ProcessName for the Display */
 #endif
+#ifdef CONFIG_IPIPE
+	void *ptd[IPIPE_ROOT_NPTDKEYS];
+#endif
 };
 
 /*
@@ -427,6 +445,11 @@ struct task_struct {
 					/* Not implemented yet, only for 486*/
 #define PF_STARTING	0x00000002	/* being created */
 #define PF_EXITING	0x00000004	/* getting shut down */
+#ifdef CONFIG_IPIPE
+#define PF_EVNOTIFY	0x00000020	/* Notify other domains about internal events */
+#else
+#define PF_EVNOTIFY	0
+#endif /* CONFIG_IPIPE */
 #define PF_FORKNOEXEC	0x00000040	/* forked but didn't exec */
 #define PF_SUPERPRIV	0x00000100	/* used super-user privileges */
 #define PF_DUMPCORE	0x00000200	/* dumped core */
diff --git a/include/linux/spinlock.h b/include/linux/spinlock.h
index bae52d3..1462732 100644
--- a/include/linux/spinlock.h
+++ b/include/linux/spinlock.h
@@ -5,12 +5,56 @@
 
 #include <asm/system.h>
 
+#undef TYPE_EQUAL
+#define TYPE_EQUAL(lock, type) \
+	__builtin_types_compatible_p(typeof(lock), type *)
+
+#define PICK_SPINLOCK_IRQSAVE(lock, flags)				\
+do {									\
+	if (TYPE_EQUAL((lock), __ipipe_spinlock_t))			\
+		(flags) = __ipipe_spin_lock_irqsave(&((__ipipe_spinlock_t *)(lock))->__lock); \
+	else if (TYPE_EQUAL((lock), spinlock_t)) {			\
+		local_irq_save(flags);					\
+		spin_lock((spinlock_t *)(lock));			\
+	}								\
+} while (0)
+
+#define PICK_SPINUNLOCK_IRQRESTORE(lock, flags)				\
+do {									\
+	if (TYPE_EQUAL((lock), __ipipe_spinlock_t))			\
+		__ipipe_spin_unlock_irqrestore(&((__ipipe_spinlock_t *)(lock))->__lock, flags); \
+	else if (TYPE_EQUAL((lock), spinlock_t)) {			\
+		spin_unlock((spinlock_t *)(lock));			\
+		local_irq_restore(flags);				\
+	}								\
+} while (0)
+
+#define PICK_SPINLOCK_IRQ(lock)						\
+do {									\
+	if (TYPE_EQUAL((lock), __ipipe_spinlock_t))			\
+		__ipipe_spin_lock_irq(&((__ipipe_spinlock_t *)(lock))->__lock); \
+	else if (TYPE_EQUAL((lock), spinlock_t)) {			\
+		local_irq_disable();					\
+		spin_lock((spinlock_t *)(lock));			\
+	}								\
+} while (0)
+
+#define PICK_SPINUNLOCK_IRQ(lock)					\
+do {									\
+	if (TYPE_EQUAL((lock), __ipipe_spinlock_t))			\
+		__ipipe_spin_unlock_irq(&((__ipipe_spinlock_t *)(lock))->__lock); \
+	else if (TYPE_EQUAL((lock), spinlock_t)) {			\
+		spin_unlock((spinlock_t *)(lock));			\
+		local_irq_enable();					\
+	}								\
+} while (0)
+
 /*
  * These are the generic versions of the spinlocks and read-write
  * locks..
  */
-#define spin_lock_irqsave(lock, flags)		do { local_irq_save(flags);       spin_lock(lock); } while (0)
-#define spin_lock_irq(lock)			do { local_irq_disable();         spin_lock(lock); } while (0)
+#define spin_lock_irqsave(lock, flags)		PICK_SPINLOCK_IRQSAVE(lock, flags)
+#define spin_lock_irq(lock)			PICK_SPINLOCK_IRQ(lock)
 #define spin_lock_bh(lock)			do { local_bh_disable();          spin_lock(lock); } while (0)
 
 #define read_lock_irqsave(lock, flags)		do { local_irq_save(flags);       read_lock(lock); } while (0)
@@ -21,8 +65,8 @@
 #define write_lock_irq(lock)			do { local_irq_disable();        write_lock(lock); } while (0)
 #define write_lock_bh(lock)			do { local_bh_disable();         write_lock(lock); } while (0)
 
-#define spin_unlock_irqrestore(lock, flags)	do { spin_unlock(lock);  local_irq_restore(flags); } while (0)
-#define spin_unlock_irq(lock)			do { spin_unlock(lock);  local_irq_enable();       } while (0)
+#define spin_unlock_irqrestore(lock, flags)	PICK_SPINUNLOCK_IRQRESTORE(lock, flags)
+#define spin_unlock_irq(lock)			PICK_SPINUNLOCK_IRQ(lock)
 #define spin_unlock_bh(lock)			do { spin_unlock(lock);  local_bh_enable();        } while (0)
 
 #define read_unlock_irqrestore(lock, flags)	do { read_unlock(lock);  local_irq_restore(flags); } while (0)
@@ -153,6 +197,44 @@ typedef struct {
 
 #endif /* !SMP */
 
+typedef struct {
+	spinlock_t __lock;
+} __ipipe_spinlock_t;
+
+#ifdef CONFIG_IPIPE
+#define IPIPE_SPIN_LOCK_UNLOCKED	{ .__lock = SPIN_LOCK_UNLOCKED }
+#define ipipe_spinlock_t		__ipipe_spinlock_t
+#define IPIPE_DEFINE_SPINLOCK(x)	ipipe_spinlock_t x = IPIPE_SPIN_LOCK_UNLOCKED
+#define IPIPE_DECLARE_SPINLOCK(x)	extern ipipe_spinlock_t x
+
+void __ipipe_spin_lock_irq(spinlock_t *lock);
+void __ipipe_spin_unlock_irq(spinlock_t *lock);
+unsigned long __ipipe_spin_lock_irqsave(spinlock_t *lock);
+void __ipipe_spin_unlock_irqrestore(spinlock_t *lock, unsigned long x);
+void __ipipe_spin_unlock_irqbegin(ipipe_spinlock_t *lock);
+void __ipipe_spin_unlock_irqcomplete(unsigned long x);
+#define spin_lock_irqsave_cond(lock, flags) \
+	spin_lock_irqsave(lock, flags)
+#define spin_unlock_irqrestore_cond(lock, flags) \
+	spin_unlock_irqrestore(lock, flags)
+#else /* !CONFIG_IPIPE */
+#define ipipe_spinlock_t		spinlock_t
+#define IPIPE_SPIN_LOCK_UNLOCKED	SPIN_LOCK_UNLOCKED
+#define IPIPE_DEFINE_SPINLOCK(x)	spinlock_t x
+#define IPIPE_DECLARE_SPINLOCK(x)	extern spinlock_t x
+
+#define spin_lock_irqsave_cond(lock, flags) \
+	do { (void)(flags); spin_lock(lock); } while(0)
+#define spin_unlock_irqrestore_cond(lock, flags) \
+	spin_unlock(lock)
+#define __ipipe_spin_lock_irq(lock)		do { } while(0)
+#define __ipipe_spin_unlock_irq(lock)		do { } while(0)
+#define __ipipe_spin_lock_irqsave(lock)		0
+#define __ipipe_spin_unlock_irqrestore(lock, x)	do { (void)(x); } while(0)
+#define __ipipe_spin_unlock_irqbegin(lock)	do { } while(0)
+#define __ipipe_spin_unlock_irqcomplete(x)	do { (void)(x); } while(0)
+#endif /* CONFIG_IPIPE */
+
 /* "lock on reference count zero" */
 #ifndef ATOMIC_DEC_AND_LOCK
 #include <asm/atomic.h>
diff --git a/init/main.c b/init/main.c
index 510efe9..b0c63c7 100644
--- a/init/main.c
+++ b/init/main.c
@@ -412,6 +412,11 @@ asmlinkage void __init start_kernel(void)
 	softirq_init();
 	time_init();
 	WATCHDOG_RESET;
+ 	/*
+ 	 * We need to wait for the interrupt and time subsystems to be
+ 	 * initialized before enabling the pipeline.
+ 	 */
+  	ipipe_init();
 
 	/*
 	 * HACK ALERT! This is early. We're enabling the console before
@@ -548,6 +553,7 @@ static void __init do_basic_setup(void)
 #ifdef CONFIG_SYSCTL
 	sysctl_init();
 #endif
+ 	ipipe_init_proc();
 
 	/*
 	 * Ok, at this point all CPU's should be initialized, so
diff --git a/kernel/Makefile b/kernel/Makefile
index 02c4d3a..3985e7a 100644
--- a/kernel/Makefile
+++ b/kernel/Makefile
@@ -16,6 +16,7 @@ obj-y     = sched.o dma.o fork.o exec_domain.o panic.o printk.o \
 	    sysctl.o acct.o capability.o ptrace.o timer.o user.o \
 	    signal.o sys.o kmod.o context.o
 
+obj-$(CONFIG_IPIPE) += ipipe/ipipe.o
 obj-$(CONFIG_UID16) += uid16.o
 obj-$(CONFIG_MODULES) += ksyms.o
 obj-$(CONFIG_PM) += pm.o
@@ -29,4 +30,6 @@ ifneq ($(CONFIG_IA64),y)
 CFLAGS_sched.o := $(PROFILING) -fno-omit-frame-pointer
 endif
 
+subdir-$(CONFIG_IPIPE) += ipipe
+
 include $(TOPDIR)/Rules.make
diff --git a/kernel/exit.c b/kernel/exit.c
index 35283a3..33cbfc8 100644
--- a/kernel/exit.c
+++ b/kernel/exit.c
@@ -440,6 +440,7 @@ fake_volatile:
 	acct_process(code);
 #endif
 	__exit_mm(tsk);
+ 	ipipe_exit_notify(tsk);
 
 	lock_kernel();
 	sem_exit();
diff --git a/kernel/fork.c b/kernel/fork.c
index c146ad4..9b14c0d 100644
--- a/kernel/fork.c
+++ b/kernel/fork.c
@@ -271,6 +271,7 @@ struct mm_struct * mm_alloc(void)
 void __mmdrop(struct mm_struct *mm)
 {
 	BUG_ON(mm == &init_mm);
+	BUG_ON(irqs_disabled_hw());
 	pgd_free(mm->pgd);
 	check_pgt_cache();
 	destroy_context(mm);
@@ -284,6 +285,7 @@ void mmput(struct mm_struct *mm)
 {
 	if (atomic_dec_and_lock(&mm->mm_users, &mmlist_lock)) {
 		extern struct mm_struct *swap_mm;
+		ipipe_cleanup_notify(mm);
 		if (swap_mm == mm)
 			swap_mm = list_entry(mm->mmlist.next, struct mm_struct, mmlist);
 		list_del(&mm->mmlist);
@@ -598,7 +600,7 @@ static inline void copy_flags(unsigned long clone_flags, struct task_struct *p)
 {
 	unsigned long new_flags = p->flags;
 
-	new_flags &= ~(PF_SUPERPRIV | PF_USEDFPU);
+	new_flags &= ~(PF_SUPERPRIV | PF_USEDFPU | PF_EVNOTIFY);
 	new_flags |= PF_FORKNOEXEC;
 	if (!(clone_flags & CLONE_PTRACE))
 		p->ptrace = 0;
@@ -815,6 +817,10 @@ int do_fork(unsigned long clone_flags, unsigned long stack_start,
 	nr_threads++;
 	write_unlock_irq(&tasklist_lock);
 
+#ifdef CONFIG_IPIPE
+	memset(p->ptd, 0, sizeof(p->ptd));
+#endif /* CONFIG_IPIPE */
+
 	if (p->ptrace & PT_PTRACED)
 		send_sig(SIGSTOP, p, 1);
 #ifdef CONFIG_SHOW_PNAME_ON_DISPLAY
diff --git a/kernel/ipipe/Makefile b/kernel/ipipe/Makefile
new file mode 100644
index 0000000..6669e37
--- /dev/null
+++ b/kernel/ipipe/Makefile
@@ -0,0 +1,7 @@
+O_TARGET := ipipe.o
+
+obj-y := core.o
+
+export-objs := $(obj-y)
+
+include $(TOPDIR)/Rules.make
